#ifndef DEFORMATION_HH
#define DEFORMATION_HH

#include <dune/common/exceptions.hh>
#include <dune/grid/geometrygrid/coordfunction.hh>
//#include <dune/fem/space/common/functionspace.hh>

// DeformationCoordFunction
// ------------------------

//! deformation depending on a discrete function 
template <class VertexVector>
class DeformationDiscreteFunction
: public Dune::DiscreteCoordFunction< double, 3, DeformationDiscreteFunction< VertexVector > > 
{

  typedef Dune::DiscreteCoordFunction< double, 3, DeformationDiscreteFunction< VertexVector > > BaseType;
  typedef VertexVector RangeVector;
public:
  //DeformationDiscreteFunction ( const VertexVector& vertices )
  //: vertices_( vertices )
  //{}

  DeformationDiscreteFunction() {};

  // template< class HostEntity , class RangeVector >
  // void evaluate ( const HostEntity &hostEntity, unsigned int corner,
  //                 RangeVector &y ) const
  // { 
  //   DUNE_THROW(Dune::NotImplemented,"evaluate not implemented for codim > 0");
  // }

  template <class HostEntity> 
  void evaluate ( const HostEntity& entity, 
            		  unsigned int corner, 
                  RangeVector &y ) const
  {  
    // put the evaluation of the parametrization here
    RangeVector x = entity.geometry().corner(corner);
    RangeVector w = entity.geometry().local(x);

    //IDENTITY DEFORMATION
    y = entity.geometry().corner(corner);

    return;
  }

// protected:
//   const VertexVector& vertices_;
};

#endif
