#ifndef FUNCTORS
#define FUNCTORS

#include <dune/common/fvector.hh>


//funzione distanza da zero

template <typename ct, int dim>
class DIST
{
public:
  DIST(){midpoint=0.5;}
  double operator()(const Dune::FieldVector<ct,dim>& x)const
  {
    Dune::FieldVector<ct,dim> y(x);
    y-=midpoint;
    return sqrt(y*y);
  }
private:
  Dune::FieldVector<ct,dim> midpoint;
};

//--------------------------------------------//
//HERMITE INTERPOLANTS for PARAMETERS in [0,1]//
//--------------------------------------------//

//h1
template <typename ct>
class alpha10
{
public:
  alpha10(){}
  ct operator()(ct u)
  {
    return 1-3*pow(u,2)+2*pow(u,3);
  }
};

//h2
template <typename ct>
class alpha20
{
public:
  alpha20(){}
  ct operator()(ct u)
  {
    return 3*pow(u,2) - 2*pow(u,3);
  }
};

//h3
template <typename ct>
class alpha11
{
public:
  alpha11(){}
  ct operator()(ct u)
  {
    return u - 2*pow(u,2) + pow(u,3);
  }
};

//h4
template <typename ct>
class alpha21
{
public:
  alpha21(){}
  ct operator()(ct u)
  {
    return pow(u,3)-pow(u,2);
  }
};


#endif
